'gbMagnify  written in PowerBASIC by Gary Beene
'Compilable Example:
#Compile Exe
#Dim All

#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

#Include "Win32API.inc"
#Include "CommCtrl.inc"
#Resource "gbmagnify.pbr"

$Ver = "gbMagnify" + $CrLf + "Ver 1.22"

'%IDC_Graphic   = 500
%IDM_Exit      = 600
%IDM_Sep       = 601
%IDM_Left      = 602
%IDM_Right     = 603
%IDM_Up        = 604
%IDM_Down      = 605
%IDM_Plus      = 606
%IDM_Minus     = 607

%IDT_Hex       = 700
%IDT_Borders   = 701
%IDT_CrossHair = 702
%IDT_Caption   = 703
%IDT_Locator   = 704
%IDT_About     = 705
%IDT_Help      = 706
%IDT_OnTop     = 707
%IDT_Copy      = 708
%IDT_CopyT     = 709
%IDT_Zoom      = 710
%IDT_Goto      = 711

%IDC_Toolbar   = 800
%CAPTUREBLT    = 1073741824

Global hDlg, hDesktopDC, hGraphicDC,hToolbar,hImageList,hConsole,hScreen,hScreenDC As Dword
Global tTall,wWide,hTall,mMargin,Startup,Locator,gCount,tbar,caption As Long, rc As Rect
Global HexData,CrossHair,Zoom,OnTop,C(),Borders,Debug,OldProc As Long, pt As PointAPI

Function PBMain() As Long
   Debug = 0
'   Dialog New Pixels, 0, "gbMagnify",0,0,210,210, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog New Pixels, 0, "gbMagnify",0,0,210,210, %WS_Overlapped Or %WS_ClipChildren Or %WS_ThickFrame Or %WS_SysMenu To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc()
   Local dx,dy As Long, P As TOOLTIPTEXT Ptr
   Static ptm,pts,oldPTM,ptOutSide As PointAPI, RBDown As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
          BuildAcceleratorTable
          CreateScreenBuffer
          Settings_INI "get"
          gCount = 1000
          ReDim C(-Zoom To Zoom, -Zoom To Zoom)
          If pt.x = - 1 Then pt.x = 100 : pt.y = 100    'set default position on 1st session
          Dialog Get Client hDlg To dx,dy
          WHM(dx,dy)
          Control Add Graphic, hDlg, gCount, "",0,tTall,dx,dy-tTall, %WS_Border    '(2*Z+1)*w,(2*Z+1)*h
          Graphic Attach hDlg, gCount, ReDraw
          Graphic Get DC To hGraphicDC
          PostMessage hDlg, %WM_User+500,0,0
      Case %WM_User+500
          RefreshDrawing(1)
      Case %WM_Size
          Dialog Get Client hDlg To dx,dy
          WHM(dx,dy)
          Control Add Graphic, hDlg, gCount+1, "",0,tTall,dx,dy-tTall, %WS_Border    '(2*Z+1)*w,(2*Z+1)*h
          Graphic Attach hDlg, gCount+1, ReDraw
          Graphic Get DC To hGraphicDC
          DrawPixels(0)        'RefreshDrawing(0)
          Control Kill hDlg, gCount
          Incr gCount
      Case %WM_MouseWheel
         Select Case Hi(Integer,Cb.WParam)    'note the use of Integer
           Case < 0 : Zoom = Zoom + IIf(Zoom<64,1,128)
           Case > 0 : Zoom = Zoom - IIf(Zoom<64,1,128)
         End Select
         If Zoom < 1 Then Zoom = 1
         If Zoom > 32 Then Zoom = 32 : Beep
         ReDim C(-Zoom To Zoom, -Zoom To Zoom)
         Dialog Get Client hDlg To dx,dy
         WHM(dx,dy)
         RefreshDrawing(1)
      Case %WM_GETMINMAXINFO
         Dialog Get Size hDlg To dx,dy
         Local MM As MINMAXINFO Ptr
         MM=Cb.LParam
         @MM.ptMinTrackSize.y=dx+tTall+18  '<-- Min Y size of your window  dx + toolbar + caption
         @MM.ptMaxTrackSize.y=dx+tTall+18  '<-- Max Y size of your window
      Case %WM_Notify
         Select Case Cb.NmId
              Case %IDT_Hex To %IDT_GoTo   'buttons on toolbar - buttons must be sequential equates
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
         End Select
      Case %WM_Command
          Select Case Cb.Ctl
              Case %IDM_Plus
                 Zoom = Zoom + IIf(Zoom<20,1,8)
                 ReDim C(-Zoom To Zoom, -Zoom To Zoom)
                 Dialog Get Client hDlg To dx,dy
                 WHM(dx,dy)
                 RefreshDrawing(1)
              Case %IDM_Minus
                 Zoom = Zoom - IIf(Zoom<20,1,8)
                 Zoom = IIf(Zoom<2,2,Zoom)
                 ReDim C(-Zoom To Zoom, -Zoom To Zoom)
                 Dialog Get Client hDlg To dx,dy
                 WHM(dx,dy)
                 RefreshDrawing(1)
              Case %IDM_Left  : Decr Pt.x : Graphic Clear : RefreshDrawing(1)
              Case %IDM_Right : Incr Pt.x : Graphic Clear : RefreshDrawing(1)
              Case %IDM_Up    : Decr Pt.y : Graphic Clear : RefreshDrawing(1)
              Case %IDM_Down  : Incr Pt.y : Graphic Clear : RefreshDrawing(1)
              Case %IDM_Exit
                  Dialog End hDlg
              Case %IDT_Copy
                  Sleep 500 : keybd_event(%VK_SnapShot, 1, 0, 0)
              Case %IDT_CopyT
                  Clipboard Reset
                  Clipboard Set Text " R=" + Str$(GetRValue(c(0,0))) + "  G=" + Str$(GetGValue(C(0,0))) + "  B=" + Str$(GetBValue(C(0,0))) + "  " _
                                  + $CrLf + " R=" + Hex$(GetRValue(c(0,0)),2) + "  G=" + Hex$(GetGValue(C(0,0)),2) + "  B=" + Hex$(GetBValue(C(0,0)),2)
              Case %IDT_CrossHair
                  CrossHair = CrossHair Xor 1 :
              Case %IDT_Caption
                  Caption = Caption Xor 1
                  Graphic Clear
                  DrawPixels(0)        'RefreshDrawing(0)
              Case %IDT_OnTop
                  OnTop = OnTop Xor 1
                  SetWindowPos hDlg, IIf(OnTop, %HWND_TOPMOST, %HWND_NOTOPMOST), 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE
              Case %IDT_Caption
                  Caption = Caption Xor 1
              Case %IDT_Borders
                  Borders = Borders Xor 1
                  Graphic Clear
                  DrawPixels(0)        'RefreshDrawing(0)
              Case %IDT_Hex
                  HexData = HexData Xor 1
                  Graphic Clear
                  DrawPixels(0)        'RefreshDrawing(0)
              Case %IDT_Locator
                  Locator = Locator Xor 1
                  Graphic Clear
                  DrawPixels(0)        'RefreshDrawing(0)
              Case %IDT_Zoom
                 Zoom = 10
                 ReDim C(-Zoom To Zoom, -Zoom To Zoom)
                 Dialog Get Client hDlg To dx,dy
                 WHM(dx,dy)
                 RefreshDrawing(1)
              Case %IDT_GoTo
                 SetCursorPos pt.x, pt.y
              Case %IDT_About
                  MsgBox $Ver + $CrLf + "Gary L. Beene", %MB_Ok + %MB_IconInformation, "About"
              Case %IDT_Help
                  ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbmagnify.htm", $Nul, $Nul, %SW_ShowNormal)
          End Select
      Case %WM_Destroy
         Settings_INI "save"
      Case %WM_RButtonDown
          RBDown = 1
          pts = pt
          GetCursorPos ptm
          oldPTM = ptm
      Case %WM_RButtonUp
          RBDown = 0
      Case %WM_LButtonDown
         SetCapture hDlg
         hDeskTopDC = GetDC(%Null)
         If CrossHair Then MousePtr 2

         GetCursorPos pt
         hDeskTopDC = GetDC(%Null)
         dx = GetPixel(hDeskTopDC,pt.x,pt.y)
         DisplayRGBValue dx
         ReleaseDC(%Null, hDeskTopDC)

      Case %WM_MouseMove
          If GetCapture = hDlg Then
              GetCursorPos pt
              GetWindowRect(hDlg,rc)
              If PtInRect(rc,pt.x,pt.y) = %False Then
                  DrawPixels(1)
                  ptOutside = pt
              Else
                  hDeskTopDC = GetDC(%Null)
                  dx = GetPixel(hDeskTopDC,pt.x,pt.y)
                  DisplayRGBValue dx
              End If
          ElseIf RBDown Then
              GetWindowRect(hDlg,rc)
              If PtInRect(rc,pt.x,pt.y) = %False Then
                  GetCursorPos ptm                                  'ptm = pt move
                  dx = ptm.x - oldPTM.x : dy = ptm.y - oldPTM.y
                  pt.x = pts.x - dx    : pt.y = pts.y - dy
                  RefreshDrawing(1)
                  ptOutside = pt
              Else
                  'no action because pt is inside the box
              End If
          End If
      Case %WM_LButtonUp
          pt = ptOutside
          ReleaseCapture
          ReleaseDC(%Null, hDeskTopDC)
          If CrossHair Then MousePtr 1
   End Select
End Function

Sub Settings_INI(Task$)
   If Debug Then cPrint LCase$(FuncName$)
   Local xresult,yresult,tempz, INIFileName As Asciiz*%MAX_PATH
   Local x,y As Long
   INIFileName = EXE.Path$ + "gbmagnify.ini"
   If Task$ = "get" Then
      Getprivateprofilestring "All", "Left", "500", xResult, %MAX_PATH, INIFileName
      Getprivateprofilestring "All", "Top", "500", yResult, %MAX_PATH, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      GetPrivateProfileString "All", "Width", "320", xResult, %MAX_PATH, INIFileName
      GetPrivateProfileString "All", "Height", "348", yResult, %MAX_PATH, INIFileName
      Dialog Set Client hDlg,Val(xResult$), Val(yResult$)   'width/height

      Getprivateprofilestring "All", "Toolbar", "1", tempz, %MAX_PATH, INIFileName
      tbar = Val(tempz)

      Getprivateprofilestring "All", "Caption", "1", tempz, %MAX_PATH, INIFileName
      Caption = Val(tempz)

      Getprivateprofilestring "All", "Locator", "0", tempz, %MAX_PATH, INIFileName
      Locator = Val(tempz)

      Getprivateprofilestring "All", "CrossHair", "0", tempz, %MAX_PATH, INIFileName
      CrossHair = Val(tempz)

      Getprivateprofilestring "All", "Borders", "1", tempz, %MAX_PATH, INIFileName
      Borders = Val(tempz)

      Getprivateprofilestring "All", "HexData", "1", tempz, %MAX_PATH, INIFileName
      HexData = Val(tempz)

      Getprivateprofilestring "All", "OnTop", "1", tempz, %MAX_PATH, INIFileName
      OnTop = Val(tempz)
      Getprivateprofilestring "All", "Zoom", "10", tempz, %MAX_PATH, INIFileName
      Zoom = Val(tempz)

      Getprivateprofilestring "All", "ptx", "-1", tempz, %MAX_PATH, INIFileName
      pt.x = Val(tempz)

      Getprivateprofilestring "All", "pty", "-1", tempz, %MAX_PATH, INIFileName
      pt.y = Val(tempz)

      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Hex, %TBState_Checked * HexData Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Borders, %TBState_Checked * Borders Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CrossHair, %TBState_Checked * CrossHair Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Caption, %TBState_Checked * Caption Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Locator, %TBState_Checked * Locator Or %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_OnTop, %TBState_Checked * OnTop Or %TBState_Enabled
      If OnTop Then SetWindowPos hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE

   ElseIf Task$ = "save" Then
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Client hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      WritePrivateProfileString "All", "Toolbar", (Str$(tbar)), INIFileName
      WritePrivateProfileString "All", "Caption", (Str$(Caption)), INIFileName
      WritePrivateProfileString "All", "Locator", (Str$(Locator)), INIFileName
      WritePrivateProfileString "All", "CrossHair", (Str$(CrossHair)), INIFileName
      WritePrivateProfileString "All", "Borders", (Str$(Borders)), INIFileName
      WritePrivateProfileString "All", "HexData", (Str$(HexData)), INIFileName
      WritePrivateProfileString "All", "Zoom", (Str$(Zoom)), INIFileName
      WritePrivateProfileString "All", "OnTop", (Str$(OnTop)), INIFileName
      WritePrivateProfileString "All", "ptx", (Str$(pt.x)), INIFileName
      WritePrivateProfileString "All", "pty", (Str$(pt.y)), INIFileName
   End If
End Sub

Sub RefreshDrawing(Flag As Long)
   If Debug Then cPrint LCase$(FuncName$)
   SetCapture hDlg
   hDeskTopDC = GetDC(%Null)
   DrawPixels(Flag)
   ReleaseDC(%Null, hDeskTopDC)
   ReleaseCapture
End Sub

Sub BuildAcceleratorTable
   If Debug Then cPrint LCase$(FuncName$)
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(5)
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Left     : ac(c).cmd   = %IDM_Right      : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Right    : ac(c).cmd   = %IDM_Left       : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Up       : ac(c).cmd   = %IDM_Down         : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Down     : ac(c).cmd   = %IDM_Up       : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Add      : ac(c).cmd   = %IDM_Plus       : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Subtract : ac(c).cmd   = %IDM_Minus      : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub DisplayRGBValue(iColor As Long)
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$
   If Caption Then
       If HexData Then
           temp$ = " " + Hex$(GetRValue(iColor),2) + " " + Hex$(GetGValue(iColor),2) + " " + Hex$(GetBValue(iColor),2) + "  "
       Else
           temp$ = Str$(GetRValue(iColor)) + Str$(GetGValue(iColor)) + Str$(GetBValue(iColor)) + "  "
       End If
       Dialog Set Text hDlg, "gbMagnify    RGB" + IIf$(Caption, temp$, "") + "   " + Str$(Pt.x) + "." + Str$(Pt.y) + "    (" + LTrim$(Str$(Zoom))+")"
   Else
       Dialog Set Text hDlg, "gbMagnify"
   End If
End Sub

Sub CreateToolbar
   If Debug Then cPrint LCase$(FuncName$)
    'toolbar
    Local hTips As Dword, i As Long

    'imagelist for the toolbar
    ImageList New Icon 16,16,32,15 To hImageList
    ImageList Add Icon hImageList, "a"          '1
    ImageList Add Icon hImageList, "about"      '2
    ImageList Add Icon hImageList, "help"       '3
    ImageList Add Icon hImageList, "hex"        '4
    ImageList Add Icon hImageList, "border"     '5
    ImageList Add Icon hImageList, "cursor"     '6
    ImageList Add Icon hImageList, "caption"    '7
    ImageList Add Icon hImageList, "locator"    '8
    ImageList Add Icon hImageList, "ontop"      '9
    ImageList Add Icon hImageList, "copy"      '10
    ImageList Add Icon hImageList, "copyt"     '11
    ImageList Add Icon hImageList, "zoom"      '12
    ImageList Add Icon hImageList, "goto"      '13

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar

    hTips = SendMessage(GetDlgItem(hDlg, %IDC_Toolbar), %TB_GETTOOLTIPS, 0, 0)
    OldProc = SetWindowLong(hToolbar, %GWL_WndProc, CodePtr(NewProc))  'subclass
    SetWindowLong hTips, %GWL_STYLE, GetWindowLong(hTips, %GWL_STYLE) Or %TTS_ALWAYSTIP

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10, %IDT_Copy,  %TbStyle_Button,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11, %IDT_CopyT,  %TbStyle_Button,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12, %IDT_Zoom,  %TbStyle_Button,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 13, %IDT_GoTo,  %TbStyle_Button,""
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5, %IDT_Borders,  %TbStyle_Check,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8, %IDT_Locator,  %TbStyle_Check,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6, %IDT_CrossHair,%TbStyle_Check,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7, %IDT_Caption,    %TbStyle_Check,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4, %IDT_Hex,      %TbStyle_Check,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9, %IDT_OnTop,    %TbStyle_Check,""
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2, %IDT_About,    %TbStyle_Button,""
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3, %IDT_Help,     %TbStyle_Button,""

    Control Get Size hDlg, %IDC_Toolbar To i,tTall
End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then cPrint LCase$(FuncName$)
   Select Case cID
      Case %IDT_Hex            : Function = "Display RGB in Hex Format"
      Case %IDT_Borders        : Function = "Display Border Around Cells"
      Case %IDT_CrossHair      : Function = "Display CrossHair Cursor
      Case %IDT_Caption        : Function = "Display Color/Position"
      Case %IDT_Locator        : Function = "Display Locator"
      Case %IDT_OnTop          : Function = "On Top"
      Case %IDT_About          : Function = "About Dialog"
      Case %IDT_Help           : Function = "Help (Web Site)"
      Case %IDT_Copy           : Function = "Copy Image to Clipboard"
      Case %IDT_CopyT          : Function = "Copy Color Data to Clipboard (text)"
      Case %IDT_Zoom           : Function = "Set Pixel Border to 10"
      Case %IDT_GoTo           : Function = "Move Cursor to Point
      Case Else                : Function = "Unknown"
   End Select
End Function

Sub CPrint (SOut As String)
   Static cWritten, iCount As Long
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   sOut = Format$(iCount,"000000  ") + sOut
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
   Incr iCount
End Sub

Sub WHM(dx As Long, dy As Long)
   If Debug Then cPrint LCase$(FuncName$)
   wWide = dx/(2*Zoom+1)+1 : hTall = wWide : mMargin = (dx-(2*Zoom+1)*wWide)\2
End Sub

Sub CreateScreenBuffer
   Local dw,dh As Long
'   Desktop Get Size To dw,dh
   dw = GetSystemMetrics(%SM_CXVirtualScreen)
   dh = GetSystemMetrics(%SM_CYVirtualScreen)
   Graphic Bitmap New dw,dh To hScreen
End Sub

Sub DrawPixels(Flag As Long)
   If Debug Then cPrint LCase$(FuncName$)
   Local s,dx,dy,x,y,x1,y1,x2,y2,wNew,hNew As Long

   If Startup  Then Exit Sub
   If Zoom > UBound(C) Then Exit Sub

   If Flag Then
       Local dw,dh As Long, bmp$, p,pStart,pMax As Long Ptr
'       Desktop Get Size To dw,dh
       dw = GetSystemMetrics(%SM_CXVirtualScreen)
       dh = GetSystemMetrics(%SM_CYVirtualScreen)
       Graphic Attach hScreen,0
       Graphic Get DC To hScreenDC
       BitBlt hScreenDC, 0,0,dw,dh, hDeskTopDC, 0,0, %SRCCopy Or %CaptureBlt 'copy desktop image to
       Graphic Get Bits To bmp$
       Graphic Attach hDlg, gCount, ReDraw
       Graphic Get DC To hGraphicDC
       pStart = StrPtr(bmp$)+8
       pMax = pStart + Len(bmp$)*4
   End If

   Graphic Clear
   For x = -Zoom To Zoom       : x1 = (x+Zoom)*wWide + mMargin
       For y = -Zoom To Zoom   : y1 = (y+Zoom)*hTall + mMargin
'         If Flag Then C(x,y) = GetPixel(hDeskTopDC,pt.x+x,pt.y+y)
         If Flag Then
             If (pt.x+x) < 0 Or (pt.x+x) >= dw Or (pt.y+y) < 0 Or (pt.y+y) >= dh Then
                 C(x,y) = 0
             Else
                 p = pStart + ((pt.y+y)*dw+(pt.x+x))*4
                 C(x,y) = RGB(@p)
             End If
         End If
         If x=0 And y=0 Then
            Graphic Width 2
            Graphic Box (x1-1,y1-1)-(x1+wWide,y1+hTall),0,%Red,C(x,y)
         Else
            Graphic Width 1
            If Borders And wWide > 8 Then
                Graphic Box (x1,y1)-(x1+wWide-1,y1+hTall-1),0,-1,C(x,y)
            Else
                Graphic Box (x1,y1)-(x1+wWide,y1+hTall),0,C(x,y),C(x,y)
            End If
         End If
   Next y : Next x

   If Locator Then
       s = 60 : Graphic Width 2
'       Desktop Get Size To dx,dy
       dw = GetSystemMetrics(%SM_CXVirtualScreen)
       dh = GetSystemMetrics(%SM_CYVirtualScreen)
       wNew = dw / Max(dw / s, dh / s)
       hNew = dh / Max(dw / s, dh / s)
       Graphic Box (10,10)-(10+wNew,10+hNew),0,%Black,RGB(255,170,120)
       x = pt.x/dw*wNew+10 : y = pt.y/dw*hNew+10
       Graphic Box (x-2,y-2)-(x+2,y+2),0,%Black,%Red
   End If

   Graphic ReDraw
   DisplayRGBValue C(0,0)
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local ptb As Point
   Select Case Msg
      Case %WM_LButtonDown
          ptb.x = Lo(Integer,lParam) :  ptb.y = Hi(Integer,lParam)
          Select Case  SendMessage( hToolbar, %TB_HitTest,0,VarPtr(ptb))
              Case 3   'zero-based
                 SetCursorPos pt.x, pt.y
                 MouseSonar(2)
                 SetCapture hDlg
                 hDeskTopDC = GetDC(%Null)
                 If CrossHair Then MousePtr 2
                 DrawPixels(0)
                 Function = 0 : Exit Function
          End Select
   End Select
   Function = CallWindowProc(OldProc, hWnd, Msg, wParam, lParam)
End Function


Sub MouseSonar(sCount As Long)
   Local i,oldState,retval, SonarState As Long
   'Retrieve current MouseSonar state:  1 =  on, 0 = off
    retval = SystemParametersInfo(%SPI_GETMOUSESONAR,0,SonarState,0)
    oldState = SonarState
    If SonarState Then
      'Synthesize pressing the Control key
      For i = 0 To sCount-1
         keybd_event(%VK_LCONTROL, &H45, 0, 0)
         keybd_event(%VK_LCONTROL, &H45, %KEYEVENTF_KEYUP, 0)
         Sleep 500
      Next i
    Else
      'Turn on the mouse sonar feature on the user's PC
      SonarState = SonarState Xor 1
      retval = SystemParametersInfo(%SPI_SETMOUSESONAR,0,ByVal SonarState,%SPIF_SENDCHANGE)
      If retVal = 0 Then ? "Mouse sonar feature not supported!", %MB_Ok + %MB_IconExclamation, "Mouse Sonar"
      'Synthesize pressing the Control key
      For i = 0 To sCount-1
          keybd_event(%VK_LCONTROL, &H45, 0, 0)
          keybd_event(%VK_LCONTROL, &H45, %KEYEVENTF_KEYUP, 0)
          Sleep 500
      Next i
      SonarState = SonarState Xor 1
      retval = SystemParametersInfo(%SPI_SETMOUSESONAR,0,ByVal oldState,%SPIF_SENDCHANGE)  'restore setting
    End If
End Sub
